<div align="center">
<img src="https://i.imgur.com/zTCTCWG.png" alt="Magma logo" align="middle"></img>

[![Forge Version](https://img.shields.io/badge/Minecraft%20Forge-1.16.5%20--%2036.2.35%20--%204e47eab4-orange.svg?style=flat)](https://files.minecraftforge.net/net/minecraftforge/forge/index_1.16.5.html)
[![Bukkit Version](https://img.shields.io/badge/Bukkit-1.16%20R5-blue?style=flat)](https://hub.spigotmc.org/stash/projects/SPIGOT/repos/bukkit/browse)
[![CraftBukkit Version](https://img.shields.io/badge/CraftBukkit-Build%2029dd68e-orange?style=flat)](https://hub.spigotmc.org/stash/projects/SPIGOT/repos/craftbukkit/browse?at=refs%2Fheads%2Fversion%2F1.16.5)
[![Spigot Build](https://img.shields.io/badge/Spigot-Build%20988b411-yellow?style=flat)](https://hub.spigotmc.org/stash/projects/SPIGOT/repos/spigot/browse) 
[![Build Status](https://git.magmafoundation.org/magmafoundation/Magma-1-16-x/badges/1.16.x/pipeline.svg)](https://git.magmafoundation.org/magmafoundation/Magma-1-16-x/-/pipelines)
[![](https://img.shields.io/discord/612695539729039411.svg?logo=discord&logoWidth=18&colorB=7289DA)](https://discord.gg/magma)
</div>

# ❗ Note: This version is End Of Life and will no longer be updated.
Please use Magma [1.12.2](https://git.magmafoundation.org/magmafoundation/Magma) or [1.18.2](https://git.magmafoundation.org/magmafoundation/Magma-1-18-x) instead.

If you need a 1.16 Forge/Bukkit implementation, checkout [Mohist](https://github.com/MohistMC/Mohist/tree/1.16.5) (active) or [Arclight](https://github.com/IzzelAliz/Arclight/tree/1.16) (LTS).

## ❓ About

Magma is the next generation of hybrid minecraft server softwares.

Magma is based on **Forge and Paper**, meaning it can run both **Craftbukkit/Spigot/Paper plugins and Forge mods**.

We hope to eliminate all issues with craftbukkit forge servers. In the end, we envision a seamless, low lag Magma experience with support for newer 1.12+ versions of Minecraft.

<details>
   <summary><b>Click here to see a screenshot!</b></summary>
   <img src="https://i.imgur.com/Rr4t7XQ.png" alt="EssentialsX with Chisel and Biomes O' Plenty" width="640">
   </br><a href="https://essentialsx.net/">EssentialsX</a> with <a href="https://www.curseforge.com/minecraft/mc-mods/chisel">Chisel</a> and <a href="https://www.curseforge.com/minecraft/mc-mods/biomes-o-plenty">Biomes O' Plenty</a>
</details>

## ☕ Java 16
Magma for 1.16 works best with **Java 8**. Java Versions up to Java 15 should work fine without any problems.</br>
If you want to use Java 16, please add the following arguments to your start script before the server-jar.

`--add-exports=java.base/sun.security.util=ALL-UNNAMED --add-exports=jdk.naming.dns/com.sun.jndi.dns=java.naming --add-opens=java.base/java.util.jar=ALL-UNNAMED --add-opens=java.base/java.lang=ALL-UNNAMED`

If you need a higher version of Java for other applications, you can install both versions and use `"<path to java.exe>" -jar magma.jar` instead of `java -jar magma.jar`.

## 🌐 BungeeCord/Velocity

Magma 1.16 is **not** compatible with [Velocity](https://velocitypowered.com/downloads) or any [BungeeCord](https://github.com/SpigotMC/BungeeCord) fork.

This is **caused by Forge** and not a fault of Magma. We cannot fix this ourselves without modifying the client.

You might be able to use the Waterfall fork called [Lightfall](https://github.com/ArclightPowered/lightfall), but it requires a clientside-mod in order to work.

## 🧪 Magma for 1.12+/1.18+

Magma for Minecraft 1.12 and above can be found in their own repositories.

- Click [here](https://git.magmafoundation.org/magmafoundation/Magma) to visit the 1.12 repository.
- Click [here](https://git.magmafoundation.org/magmafoundation/Magma-1.18.x) to visit the 1.18 repository.

## 🪣 Deployment

### Installation

1. Download the latest builds from the [**Releases** section](https://git.magmafoundation.org/magmafoundation/Magma-1-16-x/-/releases/) (**Download** the one that ends in **installer**) 
   1. Or Download the latest jar from [Magma Site](https://magmafoundation.org/)
2. Make a new directory (folder) for the server
3. Move the jar that you downloaded into the new directory
4. Run the jar with your command prompt or terminal, going to your directory and entering `java -jar Magma-[version]-installer.jar --installServer`. Change [version] to your Magma version number.
   1. Or double click the installer, like you would using normal Forge.  
5. This will generate another jar `forge-[version].jar` run this as normal `java -jar forge-[version].jar`

### Building the sources

- Clone the Project
    - You can use Git GUI (like GitHub Desktop/GitKraken) or clone using the terminal using:
        - `git clone https://git.magmafoundation.org/magmafoundation/Magma-1-16-x`
- Building
    - First you want to run the build command
        - `./gradlew setup installerJar`
    - Now go and get a drink this may take some time
    - Navigate to `projects/magma/build/libs` directory of the compiled source code
    - Copy the Jar to a new server directory (see Installation)
    
## ⚙️ Contributing

If you wish to inspect Magma, submit PRs, or otherwise work with Magma itself, you're in the right place!.

Please read the [CONTRIBUTING.md](https://git.magmafoundation.org/magmafoundation/Magma-1-16-x/CONTRIBUTING.md) to see how to contribute, setup, and run.

## 💬 Chat

You are welcome to visit Magma's Discord server [here](https://discord.gg/Magma) (recommended).

You could also go to Magma's subreddit [here](https://www.reddit.com/r/Magma).

## 👥 Partners

![YourKit-Logo](https://www.yourkit.com/images/yklogo.png)

[YourKit](http://www.yourkit.com/), makers of the outstanding java profiler, support open source projects of all kinds with their full featured [Java](https://www.yourkit.com/java/profiler/index.jsp) and [.NET](https://www.yourkit.com/.net/profiler/index.jsp) application profilers.
