/*
 * Magma Server
 * Copyright (C) 2019-2022.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package org.magmafoundation.magma.craftbukkit.entity;

import org.bukkit.craftbukkit.v1_16_R3.CraftServer;
import org.bukkit.craftbukkit.v1_16_R3.entity.CraftMinecartContainer;
import org.bukkit.entity.EntityType;
import org.jetbrains.annotations.NotNull;

import net.minecraft.entity.item.minecart.AbstractMinecartEntity;

/**
 * CraftCustomMinecartConatiner
 *
 * @author Hexeption admin@hexeption.co.uk
 * @since 23/10/2021 - 08:12 pm
 */
public class CraftCustomMinecartConatiner extends CraftMinecartContainer {

	private final EntityType entityType;

	public CraftCustomMinecartConatiner(CraftServer server, AbstractMinecartEntity entity) {
		super(server, entity);
		this.entityType = entity.getBukkitEntity().getType();
	}

	@Override
	public @NotNull EntityType getType() {
		return entityType;
	}

	@Override
	public String toString() {
		return "CraftCustomMinecartConatiner{" +
				"entityType=" + entityType +
				'}';
	}
}
